From bc837d3f74e822be1bf3771931996fd4e2ebcb3f Mon Sep 17 00:00:00 2001
From: Serghei Mihai <smihai@entrouvert.com>
Date: Tue, 3 Dec 2019 15:52:51 +0100
Subject: [PATCH] authentic2: remove authentication blocks hidden conditions
 (#41141)

---
 templates/authentic2/login.html                                 | 2 +-
 templates/variants/metz-metropole-2019/authentic2/login.html    | 2 --
 templates/variants/toodego/authentic2/login.html                | 2 +-
 templates/variants/toulouse-metropole/authentic2/login.html     | 2 +-
 templates/variants/toulouse/authentic2/login.html               | 2 +-
 .../variants/universite-paris-nanterre/authentic2/login.html    | 2 +-
 6 files changed, 5 insertions(+), 7 deletions(-)

diff --git a/templates/authentic2/login.html b/templates/authentic2/login.html
index b56b888a..12a7bb69 100644
--- a/templates/authentic2/login.html
+++ b/templates/authentic2/login.html
@@ -26,7 +26,7 @@
 {% if blocks|length == 1 %}
 <h2>Connexion</h2>
 {% endif %}
-<div {% if login_block.is_hidden %}style="display: none"{% endif %}{% if login_block.extra_css_class %} class="{{ login_block.extra_css_class }}"{% endif %}>
+<div {% if login_block.extra_css_class %} class="{{ login_block.extra_css_class }}"{% endif %}>
 {{ login_block.content|safe }}
 </div>
 </div>
diff --git a/templates/variants/metz-metropole-2019/authentic2/login.html b/templates/variants/metz-metropole-2019/authentic2/login.html
index d256356d..1b7f9046 100644
--- a/templates/variants/metz-metropole-2019/authentic2/login.html
+++ b/templates/variants/metz-metropole-2019/authentic2/login.html
@@ -2,13 +2,11 @@
 
 {% block login-blocks %}
 {% for id, login_block in blocks.items %}
-{% if not login_block.is_hidden %}
 <div class="block block-{{id}}">
 <h2>{% if id == "password" %}S'identifier{% else %}{{ login_block.name }}{% endif %}</h2>
 <div>
 {{ login_block.content|safe }}
 </div>
 </div>
-{% endif %}
 {% endfor %}
 {% endblock %}
diff --git a/templates/variants/toodego/authentic2/login.html b/templates/variants/toodego/authentic2/login.html
index c7032740..eb9821a0 100644
--- a/templates/variants/toodego/authentic2/login.html
+++ b/templates/variants/toodego/authentic2/login.html
@@ -8,7 +8,7 @@
 {% if blocks|length == 1 %}
 <h2>Connexion</h2>
 {% endif %}
-<div {% if login_block.is_hidden %}style="display: none"{% endif %}>
+<div>
 {{ login_block.content|safe }}
 </div>
 </div>
diff --git a/templates/variants/toulouse-metropole/authentic2/login.html b/templates/variants/toulouse-metropole/authentic2/login.html
index 59f440cb..ab2f72e4 100644
--- a/templates/variants/toulouse-metropole/authentic2/login.html
+++ b/templates/variants/toulouse-metropole/authentic2/login.html
@@ -16,7 +16,7 @@ ci-dessous :</p>
 
 <div id="login-blocks">
 {% for id, login_block in blocks.items %}
-<div class="a2-block" id="frontend-login-{{id}}" {% if login_block.is_hidden %}style="display: none"{% endif %}>
+<div class="a2-block" id="frontend-login-{{id}}">
 {% if blocks|length > 1 %}
 <h2>{% if id == "password" %}Vos identifiants{% else %}{{ login_block.name }}{% endif %}</h2>
 {% endif %}
diff --git a/templates/variants/toulouse/authentic2/login.html b/templates/variants/toulouse/authentic2/login.html
index 59f440cb..ab2f72e4 100644
--- a/templates/variants/toulouse/authentic2/login.html
+++ b/templates/variants/toulouse/authentic2/login.html
@@ -16,7 +16,7 @@ ci-dessous :</p>
 
 <div id="login-blocks">
 {% for id, login_block in blocks.items %}
-<div class="a2-block" id="frontend-login-{{id}}" {% if login_block.is_hidden %}style="display: none"{% endif %}>
+<div class="a2-block" id="frontend-login-{{id}}">
 {% if blocks|length > 1 %}
 <h2>{% if id == "password" %}Vos identifiants{% else %}{{ login_block.name }}{% endif %}</h2>
 {% endif %}
diff --git a/templates/variants/universite-paris-nanterre/authentic2/login.html b/templates/variants/universite-paris-nanterre/authentic2/login.html
index e26ce844..cf8ea857 100644
--- a/templates/variants/universite-paris-nanterre/authentic2/login.html
+++ b/templates/variants/universite-paris-nanterre/authentic2/login.html
@@ -4,7 +4,7 @@
 
 {% block login-blocks %}
 {% for id, login_block in blocks.items reversed %}
-<div class="block block-{{id}}" {% if login_block.is_hidden %}style="display: none"{% endif %}>
+<div class="block block-{{id}}">
 <div>
 {{ login_block.content|safe }}
 </div>
-- 
2.26.0