From aa22e751d7d4b9d57be2b100e7126c54b103107b Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Fr=C3=A9d=C3=A9ric=20P=C3=A9ters?= <fpeters@entrouvert.com>
Date: Tue, 31 Mar 2020 20:39:40 +0200
Subject: [PATCH] debian: switch to uwsgi (#41204)

---
 debian/control       |  3 ++-
 debian/uwsgi.ini     | 26 ++++++++++++++++++++++++
 debian/welco.init    | 47 ++++++++++----------------------------------
 debian/welco.install |  1 +
 debian/welco.service | 15 +++++++-------
 5 files changed, 46 insertions(+), 46 deletions(-)
 create mode 100644 debian/uwsgi.ini

diff --git a/debian/control b/debian/control
index 9c8b289..b0cc82e 100644
--- a/debian/control
+++ b/debian/control
@@ -28,7 +28,8 @@ Depends: ${misc:Depends},
     python-psycopg2,
     python-django-mellon,
     python-xstatic-select2,
-    gunicorn,
+    uwsgi,
+    uwsgi-plugin-python,
     graphicsmagick
 Recommends: nginx
 Suggests: postgresql
diff --git a/debian/uwsgi.ini b/debian/uwsgi.ini
new file mode 100644
index 0000000..462e41c
--- /dev/null
+++ b/debian/uwsgi.ini
@@ -0,0 +1,26 @@
+[uwsgi]
+auto-procname = true
+procname-prefix-spaced = welco
+
+plugin = python
+module = welco.wsgi:application
+
+http-socket = /run/welco/welco.sock
+chmod-socket = 666
+vacuum = true
+
+master = true
+processes = 5
+harakiri = 120
+enable-threads = true
+
+buffer-size = 32768
+
+py-tracebacker = /run/welco/py-tracebacker.sock.
+stats = /run/welco/stats.sock
+
+ignore-sigpipe = true
+
+if-file = /etc/welco/uwsgi-local.ini
+  include = /etc/welco/uwsgi-local.ini
+endif =
diff --git a/debian/welco.init b/debian/welco.init
index be90e78..4cc71ae 100644
--- a/debian/welco.init
+++ b/debian/welco.init
@@ -16,14 +16,12 @@
 PATH=/sbin:/usr/sbin:/bin:/usr/bin
 DESC="Multichannel request processing"
 NAME=welco
-DAEMON=/usr/bin/gunicorn
+DAEMON=/usr/bin/uwsgi
 RUN_DIR=/run/$NAME
 PIDFILE=$RUN_DIR/$NAME.pid
 LOG_DIR=/var/log/$NAME
 SCRIPTNAME=/etc/init.d/$NAME
 BIND=unix:$RUN_DIR/$NAME.sock
-WORKERS=5
-TIMEOUT=30
 
 WELCO_SETTINGS_FILE=/usr/lib/$NAME/debian_config.py
 MANAGE_SCRIPT="/usr/bin/$NAME-manage"
@@ -37,17 +35,10 @@ GROUP=$NAME
 # Read configuration variable file if it is present
 [ -r /etc/default/$NAME ] && . /etc/default/$NAME
 
-DAEMON_ARGS=${DAEMON_ARGS:-"--pid $PIDFILE \
---user $USER --group $GROUP \
---daemon \
---access-logfile $LOG_DIR/gunicorn-access.log \
---log-file $LOG_DIR/gunicorn-error.log \
---bind=$BIND  \
---workers=$WORKERS \
---worker-class=sync \
---timeout=$TIMEOUT \
---name $NAME \
-$NAME.wsgi:application"}
+DAEMON_ARGS=${DAEMON_ARGS:-"--pidfile=$PIDFILE
+--uid $USER --gid $GROUP
+--ini /etc/$NAME/uwsgi.ini
+--daemonize /var/log/uwsgi.$NAME.log"}
 
 # Load the VERBOSE setting and other rcS variables
 . /lib/init/vars.sh
@@ -73,9 +64,7 @@ do_start()
     #   0 if daemon has been started
     #   1 if daemon was already running
     #   2 if daemon could not be started
-    start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
-        || return 1
-    start-stop-daemon --start --quiet --exec $DAEMON -- \
+    start-stop-daemon --start --quiet --user $USER --exec $DAEMON -- \
         $DAEMON_ARGS \
         || return 2
 }
@@ -90,32 +79,16 @@ do_stop()
     #   1 if daemon was already stopped
     #   2 if daemon could not be stopped
     #   other if a failure occurred
-    start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE
-    RETVAL="$?"
-    [ "$RETVAL" = 2 ] && return 2
-    # Wait for children to finish too if this is a daemon that forks
-    # and if the daemon is only ever run from this initscript.
-    # If the above conditions are not satisfied then add some other code
-    # that waits for the process to drop all resources that could be
-    # needed by services started subsequently.  A last resort is to
-    # sleep for some time.
-    start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
-    [ "$?" = 2 ] && return 2
-    # Many daemons don't delete their pidfiles when they exit.
+    $DAEMON --stop $PIDFILE
     rm -f $PIDFILE
-    return "$RETVAL"
+    return 0 # hopefully
 }
 
 #
 # Function that sends a SIGHUP to the daemon/service
 #
 do_reload() {
-    #
-    # If the daemon can reload its configuration without
-    # restarting (for example, when it is sent a SIGHUP),
-    # then implement that here.
-    #
-    start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name `basename $DAEMON`
+    $DAEMON --reload $PIDFILE
     return 0
 }
 
@@ -151,7 +124,7 @@ case "$1" in
     esac
     ;;
   status)
-    status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
+    status_of_proc -p $PIDFILE "$DAEMON" "$NAME" && exit 0 || exit $?
     ;;
   reload|force-reload)
     #
diff --git a/debian/welco.install b/debian/welco.install
index d34622b..5e0477d 100644
--- a/debian/welco.install
+++ b/debian/welco.install
@@ -1,4 +1,5 @@
 debian/welco-manage       /usr/bin
 debian/settings.py        /etc/welco
+debian/uwsgi.ini          /etc/welco
 debian/debian_config.py   /usr/lib/welco
 debian/welco.service      /lib/systemd/system
diff --git a/debian/welco.service b/debian/welco.service
index b2c3549..124d9db 100644
--- a/debian/welco.service
+++ b/debian/welco.service
@@ -1,26 +1,25 @@
 [Unit]
 Description=Welco
-After=network.target postgresql.service
+After=network.target syslog.target postgresql.service
 Wants=postgresql.service
 
 [Service]
 Environment=WELCO_SETTINGS_FILE=/usr/lib/%p/debian_config.py
+Environment=LANG=C.UTF-8
 User=%p
 Group=%p
 ExecStartPre=/usr/bin/welco-manage migrate_schemas --noinput --verbosity 1
 ExecStartPre=/usr/bin/welco-manage collectstatic --noinput
-ExecStart=/usr/bin/gunicorn \
-          --bind unix:/run/%p/%p.sock \
-          --worker-class=sync \
-          --workers 5 \
-          --timeout=30 \
-          --name %p \
-          %p.wsgi:application
+ExecStart=/usr/bin/uwsgi --ini /etc/%p/uwsgi.ini
 ExecReload=/bin/kill -HUP $MAINPID
+KillSignal=SIGQUIT
 TimeoutStartSec=0
 PrivateTmp=true
 Restart=on-failure
 RuntimeDirectory=welco
+Type=notify
+StandardError=syslog
+NotifyAccess=all
 
 [Install]
 WantedBy=multi-user.target
-- 
2.26.0